 % contact matrices

close all; clear all; clc

%% read population data
pop = readtable('All_data.xlsx' , 'Sheet' , 'population');
R0 = readtable ('All_data.xlsx' , 'Sheet' , 'Rnumber');
R0_min = readtable ('All_data.xlsx' , 'Sheet' , 'Rnumber_min');
R0_max = readtable ('All_data.xlsx' , 'Sheet' , 'Rnumber_max');
exits = readtable('All_data.xlsx', 'Sheet' , 'Scenarios');

%% raw contact matrices
home.wk = readtable('BBC_wk5yr.xlsx', 'Sheet' , 'home');
home.wk = table2array(home.wk(2:end , 2:end));
work.wk = readtable('BBC_wk5yr.xlsx', 'Sheet' , 'work');
work.wk = table2array(work.wk(2:end , 2:end));
school.wk = readtable('BBC_wk5yr.xlsx', 'Sheet' , 'school');
school.wk = table2array(school.wk(2:end , 2:end));
other.wk = readtable('BBC_wk5yr.xlsx', 'Sheet' , 'other');
other.wk = table2array(other.wk(2:end , 2:end));

home.wknd = readtable('BBC_wknd5yr.xlsx', 'Sheet' , 'home');
home.wknd = table2array(home.wknd(2:end , 2:end));
work.wknd = readtable('BBC_wknd5yr.xlsx', 'Sheet' , 'work');
work.wknd = table2array(work.wknd(2:end , 2:end));
school.wknd = readtable('BBC_wknd5yr.xlsx', 'Sheet' , 'school');
school.wknd = table2array(school.wknd(2:end , 2:end));
other.wknd = readtable('BBC_wknd5yr.xlsx', 'Sheet' , 'other');
other.wknd = table2array(other.wknd(2:end , 2:end));

%% NI
% popultion NI
%
pop_NI = pop.NI(1:end-1);
pop_NI = [pop_NI(1:15); sum(pop_NI(16:end))];

%reciprocal contact matrices
C_NI = reciprocal_contacts (home, work, school, other, pop_NI);

% calculating social bahaviour by tau.i
% R0 = τ. i. c
% T(t) = c.t.N
% lock down started on 23 march 2020
pop_NI = repmat(pop_NI' , 16 , 1);
R0_NI = R0.NI;

[Taui_NI , totc_NI]= social_bahaviour (C_NI , R0_NI , exits.NI);
[R0exit_NI, C1_NI] = exit_scenarios(Taui_NI, C_NI, totc_NI, exits.NI);

Rmin = R0_min.NI;
Rmax = R0_max.NI;
[T , tott]= social_bahaviour (C_NI , Rmin , exits.NI);
[R0exit_NImin, ~] = exit_scenarios(T, C_NI, tott, exits.NI);
clear T tott
[T , tott]= social_bahaviour (C_NI , Rmax , exits.NI);
[R0exit_NImax, ~] = exit_scenarios(T, C_NI, tott, exits.NI);
clear T tott Rmin Rmax
%

%%  England
pop_England = pop.England(1:end-1);
pop_England = [pop_England(1:15); sum(pop_England(16:end))];
%reciprocal contact matrices
C_England = reciprocal_contacts (home, work, school, other, pop_England);
% calculating social bahaviour by tau.i
% R0 = τ. i. c
% T(t) = c.t.N
% lock down started on 23 march 2020
pop_England = repmat(pop_England' , 16 , 1);
R0_England = R0.England;

[Taui_England , totc_EN]= social_bahaviour (C_England , R0_England , exits.England );
[R0exit_England, C1_England] = exit_scenarios(Taui_England, C_England, totc_EN, exits.England);

Rmin = R0_min.England;
Rmax = R0_max.England;
[T , tott]= social_bahaviour (C_England , Rmin , exits.England);
[R0exit_Englandmin, ~] = exit_scenarios(T, C_England, tott, exits.England);
clear T tott
[T , tott]= social_bahaviour (C_England , Rmax , exits.England);
[R0exit_Englandmax, ~] = exit_scenarios(T, C_England, tott, exits.England);
clear T tott Rmin Rmax

%%  Wales
pop_wales = pop.Wales(1:end-1);
pop_wales = [pop_wales(1:15); sum(pop_wales(16:end))];
%reciprocal contact matrices
C_wales = reciprocal_contacts (home, work, school, other, pop_wales);
% calculating social bahaviour by tau.i
% R0 = τ. i. c
% T(t) = c.t.N
% lock down started on 23 march 2020
pop_wales = repmat(pop_wales' , 16 , 1);
R0_wales = R0.Wales;

[Taui_wales , totc_wa]= social_bahaviour (C_wales , R0_wales, exits.Wales );
[R0exit_wales, C1_wales] = exit_scenarios(Taui_wales, C_wales, totc_wa, exits.Wales);


Rmin = R0_min.Wales;
Rmax = R0_max.Wales;
[T , tott]= social_bahaviour (C_wales , Rmin , exits.Wales);
[R0exit_Walesmin, ~] = exit_scenarios(T, C_wales, tott, exits.Wales);
clear T tott
[T , tott]= social_bahaviour (C_wales , Rmax , exits.Wales);
[R0exit_Walesmax, ~] = exit_scenarios(T, C_wales, tott, exits.Wales);
clear T tott Rmin Rmax
%% Scotland
pop_SC = pop.Scotland(1:end-1);
pop_SC = [pop_SC(1:15); sum(pop_SC(16:end))];
%reciprocal contact matrices
C_SC = reciprocal_contacts (home, work, school, other, pop_SC);
% calculating social bahaviour by tau.i
% R0 = τ. i. c
% T(t) = c.t.N
% lock down started on 23 march 2020
pop_SC = repmat(pop_SC' , 16 , 1);
R0_SC = R0.Scotland;

[Taui_SC , totc_SC]= social_bahaviour (C_SC , R0_SC , exits.Scotland );
[R0exit_SC, C1_SC] = exit_scenarios(Taui_SC, C_SC, totc_SC , exits.Scotland);


Rmin = R0_min.Scotland;
Rmax = R0_max.Scotland;
[T , tott]= social_bahaviour (C_SC , Rmin , exits.Scotland);
[R0exit_SCmin, ~] = exit_scenarios(T, C_SC, tott, exits.Scotland);
clear T tott
[T , tott]= social_bahaviour (C_SC , Rmax , exits.Scotland);
[R0exit_SCmax, ~] = exit_scenarios(T, C_SC, tott, exits.Scotland);
clear T tott Rmin Rmax

%% UK
pop_UK = pop.UK(1:end-1);
pop_UK = [pop_UK(1:15); sum(pop_UK(16:end))];
%reciprocal contact matrices
C_UK = reciprocal_contacts (home, work, school, other, pop_UK);
% calculating social bahaviour by tau.i
% R0 = τ. i. c
% T(t) = c.t.N
% lock down started on 23 march 2020
pop_UK = repmat(pop_UK' , 16 , 1);
R0_UK = R0.UK;

[Taui_UK , totc_UK]= social_bahaviour (C_UK , R0_UK, exits.UK );
[R0exit_UK, C1_UK] = exit_scenarios(Taui_UK, C_UK, totc_UK, exits.UK);

Rmin = R0_min.UK;
Rmax = R0_max.UK;
[T , tott]= social_bahaviour (C_UK , Rmin , exits.UK);
[R0exit_UKmin, ~] = exit_scenarios(T, C_UK, tott, exits.UK);
clear T tott
[T , tott]= social_bahaviour (C_UK , Rmax , exits.UK);
[R0exit_UKmax, ~] = exit_scenarios(T, C_UK, tott, exits.UK);
clear T tott Rmin Rmax

%% NI West Trust

pop_WHSCT = pop.WestTrust(1:end-1);
pop_WHSCT = [pop_WHSCT(1:15); sum(pop_WHSCT(16:end))];
%reciprocal contact matrices
C_WHSCT = reciprocal_contacts (home, work, school, other, pop_WHSCT);
% calculating social bahaviour by tau.i
% R0 = τ. i. c
% T(t) = c.t.N
% lock down started on 23 march 2020
pop_WHSCT = repmat(pop_WHSCT' , 16 , 1);
R0_WHSCT = R0.WestTrust;

[Taui_WHSCT , totc_B]= social_bahaviour (C_WHSCT , R0_WHSCT, exits.NI );
[R0exit_WHSCT, C1_WHSCT] = exit_scenarios(Taui_WHSCT, C_WHSCT, totc_B, exits.NI);


%% NI Belfast Trust

pop_BHSCT = pop.BelfastTrust(1:end-1);
pop_BHSCT = [pop_BHSCT(1:15); sum(pop_BHSCT(16:end))];
%reciprocal contact matrices
C_BHSCT = reciprocal_contacts (home, work, school, other, pop_BHSCT);
% calculating social bahaviour by tau.i
% R0 = τ. i. c
% T(t) = c.t.N
% lock down started on 23 march 2020
pop_BHSCT = repmat(pop_BHSCT' , 16 , 1);
R0_BHSCT = R0.BelfastTrust;

[Taui_BHSCT , totc_B]= social_bahaviour (C_BHSCT , R0_BHSCT, exits.NI );
[R0exit_BHSCT, C1_BHSCT] = exit_scenarios(Taui_BHSCT, C_BHSCT, totc_B, exits.NI);

%% NI North Trust

pop_NHSCT = pop.NorthTrust(1:end-1);
pop_NHSCT = [pop_NHSCT(1:15); sum(pop_NHSCT(16:end))];
%reciprocal contact matrices
C_NHSCT = reciprocal_contacts (home, work, school, other, pop_NHSCT);
% calculating social bahaviour by tau.i
% R0 = τ. i. c
% T(t) = c.t.N
% lock down started on 23 march 2020
pop_NHSCT = repmat(pop_NHSCT' , 16 , 1);
R0_NHSCT = R0.NorthTrust;

[Taui_NHSCT , totc_N]= social_bahaviour (C_NHSCT , R0_NHSCT, exits.NI );
[R0exit_NHSCT, C1_NHSCT] = exit_scenarios(Taui_NHSCT, C_NHSCT, totc_N, exits.NI);

%% NI South Trust

pop_SHSCT = pop.SouthTrust(1:end-1);
pop_SHSCT = [pop_SHSCT(1:15); sum(pop_SHSCT(16:end))];
%reciprocal contact matrices
C_SHSCT = reciprocal_contacts (home, work, school, other, pop_SHSCT);
% calculating social bahaviour by tau.i
% R0 = τ. i. c
% T(t) = c.t.N
% lock down started on 23 march 2020
pop_SHSCT = repmat(pop_SHSCT' , 16 , 1);
R0_SHSCT = R0.SouthTrust;

[Taui_SHSCT , totc_S]= social_bahaviour (C_SHSCT , R0_SHSCT, exits.NI );
[R0exit_SHSCT, C1_SHSCT] = exit_scenarios(Taui_SHSCT, C_SHSCT, totc_S, exits.NI);

%% NI SouthEast Trust

pop_SEHSCT = pop.SouthEastTrust(1:end-1);
pop_SEHSCT = [pop_SEHSCT(1:15); sum(pop_SEHSCT(16:end))];
%reciprocal contact matrices
C_SEHSCT = reciprocal_contacts (home, work, school, other, pop_SEHSCT);
% calculating social bahaviour by tau.i
% R0 = τ. i. c
% T(t) = c.t.N
% lock down started on 23 march 2020
pop_SEHSCT = repmat(pop_SEHSCT' , 16 , 1);
R0_SEHSCT = R0.SouthEastTrust;

[Taui_SEHSCT , totc_SE]= social_bahaviour (C_SEHSCT , R0_SEHSCT, exits.NI );
[R0exit_SEHSCT, C1_SEHSCT] = exit_scenarios(Taui_SEHSCT, C_SEHSCT, totc_SE, exits.NI);


